package Hawat::Controller::Dashboard;
use Moose;
use namespace::autoclean;
use warnings;
use strict;

use Mentat::Core qw(:c_hawat);

BEGIN {extends 'Hawat::Controller::Secure'; }

=head1 NAME

Hawat::Controller::Dashboard - Catalyst Controller

=head1 DESCRIPTION

Catalyst Controller.

=head1 METHODS

=cut


=head2 index

=cut

use constant TEMPLATE                => "template";
use constant TEMPLATE_DASHBOARD_VIEW => "dashboard/view";
use constant MODEL_DASHBOARD         => "Dashboard";

sub index :Path :Args(0) {
    my ( $self, $c ) = @_;

    my $query   = $c->req->params->{HAWAT_FORM_QUERY()};
    my $from    = $c->req->params->{HAWAT_FORM_FROM()};
    my $to      = $c->req->params->{HAWAT_FORM_TO()};
    my $result  = $c->model(MODEL_DASHBOARD())->get_dashboard($c->get_current_user_id(), $query, $from, $to);

    $c->stash(HAWAT_FORM_QUERY()      => $query);
    $c->stash(HAWAT_FORM_INTERVALS()  => $result->{HAWAT_FORM_INTERVALS()});
    $c->stash(HAWAT_FORM_DATA()       => $result->{HAWAT_FORM_DATA()});
    $c->stash(HAWAT_FORM_ERROR()      => $result->{HAWAT_FORM_ERROR()});
    $c->stash(HAWAT_FORM_FROM()       => $result->{HAWAT_FORM_FROM()});
    $c->stash(HAWAT_FORM_TO()         => $result->{HAWAT_FORM_TO()});
    $c->stash(HAWAT_TABLE_BODY()      => $result->{HAWAT_TABLE_BODY()});

    $c->stash(TEMPLATE()              => TEMPLATE_DASHBOARD_VIEW());
    $c->forward(HAWAT_FORWARD_VIEW_HTML());
}


=head1 AUTHOR

root

=head1 LICENSE

This library is free software. You can redistribute it and/or modify
it under the same terms as Perl itself.

=cut

__PACKAGE__->meta->make_immutable;

1;
